#!/usr/bin/ruby -Kn
#
require '/opt/yklook/swing'

class YKShowDir < YKLookMain
	def yki_make_display()
		ta = YKLookTextArea.new()
		yk_add( ta )

		ta.yk_set_text( YKInfoDemo.fn_info() )
	end
	def yki_title()
		return 'YKLook Information'
	end
	def yki_size()
		return [600,400]
	end
	# def yki_ht_farpath()
	#	return ['/tools', nil]
	# end
end

class YKInfoDemo
	def self.fn_info()
		logdir = YKLookLog.yk_path_find( 'YKLOOK_LOGPATH', 'yklooklog' )
		sesdir = YKLookLog.yk_path_find( 'YKLOOK_SESPATH', 'yklookses' )
		reddir = YKLookLog.yk_path_find( 'YKLOOK_REDPATH', 'yklookred' )
		logdef = YKLookLog.yk_log().yk_fullpath()
		buf = []
		buf << "working directories...\n"
		buf << 'log: ' << ( logdir ? logdir : '--- unknown ---' ) << "\n"
		buf << 'ses: ' << ( sesdir ? sesdir : '--- unknown ---' ) << "\n"
		buf << 'red: ' << ( reddir ? reddir : '--- unknown ---' ) << "\n"
		buf << "\n"
		buf << "current files...\n"
		buf << 'error-log file: '
		buf <<            ( logdef ? logdef : '--- unknown ---' ) << "\n"
		buf << "\n"
		buf << "environment variables...\n"
		buf << fn_env( 'YKLOOK_LOGPATH' )
		buf << fn_env( 'YKLOOK_SESPATH' )
		buf << fn_env( 'YKLOOK_REDPATH' )
		buf << fn_env( 'YKLOOK_USER'    )
		buf << fn_env( 'TEMP'     )
		buf << fn_env( 'TMP'      )
		buf << fn_env( 'USER'     )
		buf << fn_env( 'LOGNAME'  )
		buf << fn_env( 'USERNAME' )
		buf << "\n"
		buf << fn_env( 'YKLOOK_FARPATH' )
		buf << fn_env( 'DOCUMENT_ROOT' )
		return buf.join(nil)
	end
	def self.fn_env( prm_env )
		val = ENV[ prm_env ]
		str = val ? val : '--- undefined ---'
		return ( prm_env + ': ' + str + "\n" )
	end
	def self.fn_show()
		YKLookMain.yk_main().yk_show_dialog_message( nil, fn_info() )
	end
end

YKLookMain.yk_mainloop( YKShowDir.new() )

#
# end
