#
#  YKLook... GUI Library, window-frame (for Ruby)
#
#  Copyright (c) 2009-2010 YorozuKotowariYa Ltd.
#
class YKLookMain
	def yk_is_frame()
		return (yk_is_near() or yki_ht_opener_valid())
	end
	def yks_frame_id()
		return 0
	end
	def self.yks_frame_push( prm_id )
		@@yk_framestack.push( prm_id )
	end
	def self.yks_frame_pop()
		@@yk_framestack.pop()
	end
	def self.yks_frame_self()
		return @@yk_framepool[ @@yk_framestack[-1] ]
	end
	def self.yks_frame_add( prm_frame )
		id = YKLookSwingBase.yks_more_id()
		@@yk_framepool[id] = prm_frame
		return id
	end
	def self.yks_frame_del( prm_id )
		@@yk_framepool.delete( prm_id )
	end
	def self.yks_frames()
		return @@yk_framepool
	end
	alias yks_load_instdata_frame yks_load_instdata
	def yks_load_instdata( prm_data )
		prm_data.each_with_index() do |val,idx|
			if idx == 0
				yks_load_instdata_frame( val )
			else
				frm = Kernel.const_get( val['@yk_classname'] ).new()
				@@yk_framepool[ val['@yk_frameid'] ] = frm
				frm.yks_load_instdata_frame( val )
			end
		end
	end
	alias yks_save_instdata_frame yks_save_instdata
	def yks_save_instdata()
		ary = [ yks_save_instdata_frame() ]
		@@yk_framepool.each() do |key,val|
			if key != 0
				ary << val.yks_save_instdata_frame()
			end
		end
		return ary
	end
	def yk_find_objects( prm_name = nil, prm_no = nil )
		return YKLookSwingBase.yks_find_objects_frame( self, prm_name, prm_no )
	end
	def yk_look( prm_name = nil, prm_no = nil )
		ary = YKLookSwingBase.yks_find_objects_frame( self, prm_name, prm_no )
		if ary.size() < 1
			return nil
		end
		return ary[0]
	end
	def yk_action_callback( prm_event )
		id = prm_event.yks_frame_id()
		cb = prm_event.yk_callback()
		fr = @@yk_framepool[ id ]
		if not cb.kind_of?(String) or cb.empty?() or fr.nil?()
			return false
		end
		begin
			YKLookMain.yks_frame_push( id )
			fr.__send__( cb, prm_event )
		rescue => ex
			yks_user_error( ex, 'event_callback (' + cb + ')',
								{ 'cb' => cb, 'yks_event' => prm_event } )
		ensure
			YKLookMain.yks_frame_pop()
		end
		return true
	end
	def yks_applet_size()
		if yki_ht_opener_valid()
			begin
				siz = yki_ht_opener_size()
				yks_check_impl_array( siz, 'yki_ht_opener_size' )
				yks_check_impl_int( siz[0], 'yki_ht_opener_size' )
				yks_check_impl_int( siz[1], 'yki_ht_opener_size' )
			rescue => ex
				yks_user_error( ex, 'yki_ht_opener_size' )
			end
		else
			siz = yks_check_size()
		end
		return (' width=' + siz[0].to_s() + ' height=' + siz[1].to_s())
	end
	def yks_title()
		if yki_ht_opener_valid()
			return yki_ht_opener_title()
		end
		return yki_title()
	end
	def yks_make_display_far()
		@yk_packet = []
		yks_set_mainpanel()
		if yki_ht_opener_valid()
			catch( YKLook_Return ) do
				begin
					yki_ht_opener_display()
				rescue => ex
					yks_user_error( ex, 'yki_ht_opener_display' )
				end
			end
		else
			catch( YKLook_Return ) do
				begin
					yki_make_display()
				rescue => ex
					yks_user_error( ex, 'yki_make_dispkay' )
				end
			end
		end
	end
	def yki_ht_opener_valid()
		return false
	end
	def yki_ht_opener_title()
		return yki_title()
	end
	def yki_ht_opener_size()
		return [300,40]
	end
	def yki_ht_opener_display()
		yk_ht_opener_display()
	end
	def yki_ht_opener_button()
		return 'Open Window'
	end
	def yk_ht_opener_button()
		obj = yki_ht_opener_button()
		btn = nil
		if obj.kind_of?(String)
			btn = YKLookButton.new( obj )
		end
		if obj.kind_of?(YKLookImage)
			btn = YKLookButton.new()
			btn.yk_set_icon( obj )
		end
		if obj.kind_of?(YKLookButton)
			btn = obj
		end
		if btn.nil?()
			btn = YKLookButton.new( "Open Window...error" )
		end
		btn.yks_set_listener( 'yks_opener_callback' )
		return btn
	end
	def yk_ht_opener_display()
		btn = yk_ht_opener_button()
		pan = YKLookPanelFlow.new()
		pan.yk_add( btn )
		yk_add( pan )
	end
	def yk_ht_opener_action()
		frm = @yk_yklsdata['yk_opener_frame']
		if frm.nil?()
			frm = yks_opener_make_frame()
		end
		frm.yk_show()
	end
	def yks_opener_make_frame()
		frm = YKLookFrame.new()
		@yk_yklsdata['yk_opener_frame'] = frm
		yks_set_mainpanel( frm.yk_id() )
		ttl = yki_title()
		if ttl.kind_of?(String)
			frm.yk_set_title( ttl )
		end
		siz = yks_check_size()
		frm.yk_set_size( siz[0], siz[1] )
		frm.yk_set_resizable( yki_fr_resizable() )
		loc = yki_fr_location()
		if loc.kind_of?(Array) and loc.size() == 2
			if loc[0].nil?() or loc[0].kind_of?(Integer)
				if loc[1].nil?() or loc[1].kind_of?(Integer)
					frm.yk_set_location( loc[0], loc[1] )
				end
			end
		end
		begin
			yki_make_display()
		rescue => ex
			yks_user_error( ex, 'yki_make_dispkay' )
		end
		if yki_fr_need_pack()
			frm.yk_pack()
		end
		frm.yk_set_close_operation( 'H' )
		frm.yk_show_within_screen_later( nil, nil )
		return frm
	end
	def yks_opener_callback( prm_event )
		yk_ht_opener_action()
	end
end
class YKLookSwingBase
	def yks_frame_id()
		return @yk_frameid
	end
	def yk_var( prm_name )
		YKLookMain.yks_frame_self().yk_var( prm_name, self )
		return self
	end
	def self.yks_remove( prm_frame_id )
		@@yk_objects.each_value() do |ary|
			ary.delete_if() { |obj| obj.yks_frame_id() == prm_frame_id }
		end
	end
	def self.yk_look_frame( prm_frame, prm_name = nil, prm_no = nil )
		fid = prm_frame.yks_frame_id()
		ary = @@yk_objects[ self.to_s() ]
		if not ary.kind_of?(Array)
			return nil
		end
		target = nil
		ary.each() do |obj|
			if prm_name
				if prm_name.kind_of?(String)
					if obj.yk_tagname() != prm_name
						next
					end
				else
					if obj.yk_tagname().match( prm_name ).nil?()
						next
					end
				end
			end
			if prm_no
				if obj.yk_tagno() != prm_no
					next
				end
			end
			if obj.yks_frame_id() == fid
				target = obj
				break
			end
		end
		return target
	end
	def self.yk_find_objects_frame( prm_frame, prm_name = nil, prm_no = nil )
		fid = prm_frame.yks_frame_id()
		ary = @@yk_objects[ self.to_s() ]
		if not ary.kind_of?(Array)
			return []
		end
		target = []
		ary.each() do |obj|
			if prm_name
				if prm_name.kind_of?(String)
					if obj.yk_tagname() != prm_name
						next
					end
				else
					if obj.yk_tagname().match( prm_name ).nil?()
						next
					end
				end
			end
			if prm_no
				if obj.yk_tagno() != prm_no
					next
				end
			end
			if obj.yks_frame_id() == fid
				target << obj
			end
		end
		return target
	end
	def self.yks_find_objects_frame( prm_frame, prm_name = nil, prm_no = nil )
		fid = prm_frame.yks_frame_id()
		res = []
		@@yk_objects.each_value() do |ary|
			ary.each() do |obj|
				if prm_name
					if prm_name.kind_of?(String)
						if obj.yk_tagname() != prm_name
							next
						end
					else
						if obj.yk_tagname().match( prm_name ).nil?()
							next
						end
					end
				end
				if prm_no
					if obj.yk_tagno() != prm_no
						next
					end
				end
				if obj.yks_frame_id() == fid
					res << obj
				end
			end
		end
		return res
	end
	def yks_set_listener( prm_lis )
		if @yk_frameid != YKLookMain.yks_frame_current()
			raise YKLookErrorSwing, 'illParent'
		end
		yks_rpc( 'yk_setListener', YKLookMain.yks_encode_string( prm_lis ) )
		return self
	end
	def yks_check_listener( prm_lis )
		if @yk_frameid != YKLookMain.yks_frame_current()
			raise YKLookErrorSwing, 'illParent'
		end
		if prm_lis
			YKLookMain.yks_check_yk( prm_lis )
		end
		return YKLookMain.yks_encode_string( prm_lis )
	end
end

class YKLookMainFrame
	def yks_frame_id()
		return @yk_frameid
	end
	def yk_show_dialog_message( prm_cb, prm_gui, prm_title = nil,
								prm_type = nil, prm_icon = nil )
		YKLookMain.yk_main().
			yk_show_dialog_message( prm_cb, prm_gui, prm_title,
									prm_type, prm_icon )
	end
	def yk_show_dialog_confirm( prm_cb, prm_gui, prm_title = nil,
								prm_opttype = nil,
								prm_msgtype = nil, prm_icon = nil )
		YKLookMain.yk_main().
			yk_show_dialog_confirm( prm_cb, prm_gui, prm_title,
									prm_opttype, prm_msgtype, prm_icon )
	end
	def yk_show_dialog_option( prm_cb, prm_gui, prm_title,
								prm_opt, prm_def = nil,
								prm_type = nil, prm_icon = nil )
		YKLookMain.yk_main().
			yk_show_dialog_option( prm_cb, prm_gui, prm_title,
									prm_opt, prm_def, prm_type, prm_icon )
	end
	def yk_show_dialog_input( prm_cb, prm_gui, prm_title = nil,
								prm_type = nil, prm_icon = nil )
		YKLookMain.yk_main().
			yk_show_dialog_input( prm_cb, prm_gui, prm_title,
									prm_type, prm_icon )
	end
	def yk_show_dialog_select( prm_cb, prm_gui, prm_title,
								prm_sel, prm_def = nil,
								prm_type = nil, prm_icon = nil )
		YKLookMain.yk_main().
			yk_show_dialog_select( prm_cb, prm_gui, prm_title,
									prm_sel, prm_def, prm_type, prm_icon )
	end
	def yk_set_default_button( prm_btn )
		@yk_frame.yk_set_default_button( prm_btn )
	end
	def yk_send_client_property( prm_key, prm_val )
		@yk_frame.yk_send_client_property( prm_key, prm_val )
	end
	def yk_set_close_operation( prm_ope )
		@yk_frame.yk_set_close_operation( prm_ope )
	end
	def yk_set_icon( prm_img )
		@yk_frame.yk_set_icon( prm_img )
	end
	def yk_set_resizable( prm_bool )
		@yk_frame.yk_set_resizable( prm_bool )
	end
	def yk_set_title( prm_title )
		@yk_frame.yk_set_title( prm_title )
	end
	def yk_set_size( prm_width, prm_height )
		@yk_frame.yk_set_size( prm_width, prm_height )
	end
	def yk_set_location( prm_x, prm_y )
		@yk_frame.yk_set_location( prm_x, prm_y )
	end
	def yk_dispose()
		@yk_frame.yk_dispose()
		@yk_frame = nil
		YKLookMain.yks_frame_del( @yk_frameid )
		YKLookSwingBase.yks_remove( @yk_frameid )
	end
	def yk_pack()
		@yk_frame.yk_pack()
	end
	def yk_hide()
		@yk_frame.yk_hide()
	end
	def yk_show()
		if @yk_frame.yk_first()
			@yk_frame.yk_show_within_screen_later( nil, nil )
			@yk_frame.yk_first( false )
		else
			@yk_frame.yk_show()
		end
	end
	def yk_show_within_screen( prm_x = nil, prm_y = nil )
		if @yk_frame.yk_first()
			@yk_frame.yk_show_within_screen_later( prm_x, prm_y )
			@yk_frame.yk_first( false )
		else
			@yk_frame.yk_show_within_screen( prm_x, prm_y )
		end
	end
	def yk_add( prm_gui, *prm_pos )
		yk_rootpanel().yk_add( prm_gui, *prm_pos )
	end
	def yk_rootpanel()
		return @yk_rootpanel
	end
	def yks_set_rootpanel()
		@yk_rootpanel = YKLookPanelQuint.new()
		@yk_frame.yks_set_rootpanel( @yk_rootpanel )
	end
	def yks_check_impl_array( prm_target, prm_method, prm_size = 2 )
		if not prm_target.kind_of?(Array)
			raise YKLookErrorMain, ('implNotArray ' + prm_method)
		end
		if prm_target.size() != prm_size
			raise YKLookErrorMain, ('implIllSizeArray ' + prm_method)
		end
	end
	def yks_check_impl_int( prm_target, prm_method )
		if not prm_target.kind_of?(Integer)
			raise YKLookErrorMain, ('implNotIntArray ' + prm_method)
		end
		if prm_target <= 0 or prm_target >=4096
			raise YKLookErrorMain, ('implIllNumber ' + prm_method)
		end
	end
	def yki_title()
		return ''
	end
	def yki_size()
		return [400,300]
	end
	def yki_make_display()
		lab = YKLookLabel.new('YKLook')
		pan = YKLookPanelFlow.new()
		pan.yk_add( lab )
		yk_add( pan )
	end
	def yki_resizable()
		return true
	end
	def yki_location()
		return [ nil, nil ]
	end
	def yki_need_pack()
		return false
	end
	def yki_need_show()
		return true
	end
	def yki_closing()
	end
	def yks_callback( prm_event )
		begin
			yki_closing()
		rescue => ex
			YKLookMain.yk_main().yks_user_error( ex, 'yki_closing' )
		end
	end
	def self.yk_more_frame( prm_frame, prm_param = nil )
		case prm_param
			when NilClass  then # thru
			when Array     then # thru
			else raise YKLookErrorMain, 'illParamObject'
		end
		prm_frame.yks_more_frame( prm_param )
	end
	def yks_more_frame( prm_param = nil )
		@yk_userparam = prm_param
		@yk_frameid   = YKLookMain.yks_frame_add( self )
		@yk_instdata  = []
		begin
			YKLookMain.yks_frame_push( @yk_frameid )
			@yk_frame = YKLookFrame.new()
			yks_make_display()
		ensure
			YKLookMain.yks_frame_pop()
		end
	end
	def yks_make_display()
		yks_set_rootpanel()
		yk_set_title( yki_title() )
		siz = yki_size()
		yks_check_impl_array( siz, 'yki_size' )
		yks_check_impl_int( siz[0], 'yki_size' )
		yks_check_impl_int( siz[1], 'yki_size' )
		yk_set_size( siz[0], siz[1] )
		yk_set_resizable( yki_resizable() )
		loc = yki_location()
		if loc.kind_of?(Array) and loc.size() == 2
			if loc[0].nil?() or loc[0].kind_of?(Integer)
				if loc[1].nil?() or loc[1].kind_of?(Integer)
					yk_set_location( loc[0], loc[1] )
				end
			end
		end
		begin
			yki_make_display()
		rescue => ex
			YKLookMain.yk_main().yks_user_error( ex, 'yki_make_dispkay(frame)' )
		end
		if yki_need_pack()
			yk_pack()
		end
		if yki_need_show()
			yk_show()
		end
	end
	def self.yk_find_frame( prm_param = nil )
		case prm_param
			when NilClass   then return yks_find_frame_noparam()
			when TrueClass  then return yks_find_frame_all()
			when FalseClass then return yks_find_frame_exist()
			when Array      then # thru
			else raise YKLookErrorMain, 'illParamObject'
		end
		if prm_param.empty?()
			return yks_find_frame_empty()
		end
		res = []
		YKLookMain.yks_frames().each() do |key,val|
			if key != 0
				ary = val.yk_userparam()
				if ary.kind_of?(Array)
					flg = true
					if prm_param.size() <= ary.size()
						prm_param.each_with_index() do |item,idx|
							if not item == ary[idx]
								flg = false
								break
							end
						end
						if flg
							res << val
						end
					end
				end
			end
		end
		return res
	end
	def self.yks_find_frame_noparam()
		res = []
		YKLookMain.yks_frames().each() do |key,val|
			if key != 0
				if val.yk_userparam().nil?()
					res << val
				end
			end
		end
		return res
	end
	def self.yks_find_frame_all()
		res = []
		YKLookMain.yks_frames().each() do |key,val|
			if key != 0
				res << val
			end
		end
		return res
	end
	def self.yks_find_frame_exist()
		res = []
		YKLookMain.yks_frames().each() do |key,val|
			if key != 0
				ary = val.yk_userparam()
				if ary.kind_of?(Array)
					res << val
				end
			end
		end
		return res
	end
	def self.yks_find_frame_empty()
		res = []
		YKLookMain.yks_frames().each() do |key,val|
			if key != 0
				ary = val.yk_userparam()
				if ary.kind_of?(Array) and ary.empty?()
					res << val
				end
			end
		end
		return res
	end
	def yks_load_instdata_frame( prm_data )
		@yk_instdata = []
		prm_data.each() do |key,val|
			if key != '@yk_classname'
				instance_variable_set( key, val )
			end
			idx = key.index('@yk')
			if idx.nil?() or idx != 0
				@yk_instdata << key
			end
		end
	end
	def yks_save_instdata_frame()
		hash = { }
		hash['@yk_classname'] = self.class().to_s()
		hash['@yk_frameid'  ] = @yk_frameid
		hash['@yk_frame'    ] = @yk_frame
		hash['@yk_rootpanel'] = @yk_rootpanel
		hash['@yk_userparam'] = @yk_userparam
		@yk_instdata.each() do |key|
			hash[key] = instance_variable_get(key)
		end
		return hash
	end
	def yk_find_objects( prm_name = nil, prm_no = nil )
		return YKLookSwingBase.yks_find_objects_frame( self, prm_name, prm_no )
	end
	def yk_look( prm_name = nil, prm_no = nil )
		ary = YKLookSwingBase.yks_find_objects_frame( self, prm_name, prm_no )
		if ary.size() < 1
			return nil
		end
		return ary[0]
	end
	def yk_var( *prm_args )
		if prm_args.size() == 0
			return @yk_instdata
		end
		nam = prm_args[0]
		if not nam.kind_of?(String)
			raise YKLookErrorMain, 'notStringInArray'
		end
		if idx = nam.index('@')
			if idx != 0
				raise YKLookErrorMain, 'illNameFmt'
			end
		end
		if nam.index('@',1)
			raise YKLookErrorMain, 'illNameFmt'
		end
		YKLookMain.yks_check_yk( nam, 1 )
		tf = @yk_instdata.include?( nam )
		if not tf
			@yk_instdata << nam
		end
		if instance_variable_get( nam ).nil?()
			instance_variable_set( nam, nil )
		end
		if prm_args.size() == 2
			instance_variable_set( nam, prm_args[1] )
		end
		return tf
	end
	def yk_var_attach( prm_args )
		if not prm_args.kind_of?(Array)
			prm_args = [ prm_args ]
		end
		tf = false
		prm_args.each() do |key|
			if yk_var( key )
				tf = true
			end
		end
		return tf
	end
	def yk_var_detach( prm_args )
		if not prm_args.kind_of?(Array)
			prm_args = [ prm_args ]
		end
		tf = false
		prm_args.each() do |key|
			if @yk_instdata.include?( key )
				tf = true
				@yk_instdata.delete( key )
			end
		end
		return tf
	end
	def yk_userparam()
		return @yk_userparam
	end
end

class YKLookFrame < YKLookComponent
	def initialize()
		super()
		@yk_first = true
		yk_set_close_operation( 'd' )
	end
	def yk_first( *prm_val )
		if prm_val.size() == 0
			return @yk_first
		end
		@yk_first = prm_val[0]
	end
	def yks_set_rootpanel( prm_panel )
		yks_rpc( 'yk_setRootPanel', prm_panel.yk_id() )
	end
	def yk_set_default_button( prm_btn )
		yks_rpc( 'yk_setDefaultButton', (prm_btn ? prm_btn.yk_id() : nil) )
	end
	def yk_send_client_property( prm_key, prm_val )
		k = YKLookComponent.yks_encode_property( prm_key )
		v = YKLookComponent.yks_encode_property( prm_val )
		yks_rpc( 'yk_putClientProperty', k, v )
	end
	def yk_set_close_operation( prm_ope )
		if prm_ope.kind_of?(String)
			yks_rpc( 'yk_setDefaultCloseOperation', prm_ope )
		end
	end
	def yk_set_icon( prm_img )
		if prm_img.kind_of?(YKLookImage)
			id = prm_img.yk_id()
		else
			id = nil
		end
		yks_rpc( 'yk_setIconImage', id )
	end
	def yk_set_resizable( prm_bool )
		yks_rpc( 'yk_setResizable', (prm_bool ? 'T' : 'F') )
	end
	def yk_set_title( prm_title )
		yks_rpc( 'yk_setTitle', YKLookMain.yks_encode_string(prm_title) )
	end
	def yk_set_size( prm_width, prm_height )
		yks_rpc( 'yk_setSize', prm_width, prm_height )
	end
	def yk_set_location( prm_x, prm_y )
		yks_rpc( 'yk_setLocation', prm_x, prm_y )
	end
	def yk_dispose()
		yks_rpc( 'yk_dispose' )
	end
	def yk_pack()
		yks_rpc( 'yk_pack' )
	end
	def yk_hide()
		yks_rpc( 'yk_hide' )
	end
	def yk_show()
		yks_rpc( 'yk_show' )
	end
	def yk_show_within_screen( prm_x, prm_y )
		yks_rpc( 'yk_showWithinScreen', prm_x, prm_y )
	end
	def yk_show_within_screen_later( prm_x, prm_y )
		yks_rpc( 'yk_showWithinScreenLater', prm_x, prm_y )
	end
end

# end
